-- ForteXorcist v1.957 by Xus 13-01-2010
-- Paladin module for ForteXorcist started by Arono of Skywall

if FW.CLASS == "PALADIN" then

	local FW = FW;
	local FWL = FW.L;
	local PA = FW:ClassModule("Paladin");
	
	if FW.Modules.Timer then
	
		-- Tier 7
		--FW:RegisterSet("Redemption Plate","39638", "39639", "39640", "39641", "39642", "40579", "40580", "40581", "40583", "40584");
		
		-- istype: FW.DEFAULT FW.SHARED FW.UNIQUE FW.PET FW.CHARM FW.COOLDOWN FW.HEAL FW.BUFF
		--spell, hastarget, duration, isdot, istype, reducedinpvp, texture, stack

		-- Holy Buffs
		FW:RegisterBuff(20216); -- Divine Favor
		--FW:RegisterBuff(43837); -- Enlightenment (T5 4-Set)
		FW:RegisterBuff(64891); -- Holy Mending (T8 2-Set)
		FW:RegisterBuff(54149); -- Infusion of Light
		FW:RegisterBuff(53655); -- Judgements of the Pure
		FW:RegisterBuff(31834); -- Light's Grace
		FW:RegisterBuff(53659); -- Sacred Cleansing
		FW:RegisterBuff(54428); -- Divine Plea
		
		-- Protection Buffs
		FW:RegisterBuff(64883); -- Aegis (T8 4-Set)
		--FW:RegisterBuff(37193); -- Infused Shield (T5 4-Set)
		FW:RegisterBuff(20132); -- Redoubt
		FW:RegisterBuff(642); -- Divine Shield
		FW:RegisterBuff(48952); -- Holy Shield
		
		-- Retribution Buffs
		FW:RegisterBuff(59578); -- The Art of War
		FW:RegisterBuff(57669); -- Replenishment (Judgements of the Wise)
		FW:RegisterBuff(54203); -- Sheath of Light
		FW:RegisterBuff(20053); -- Vengeance
		
		-- Retribution Debuffs
		FW:RegisterSpell(53382, 1, 000, 1, FW.DEFAULT); -- Righteous Vengeance
			FW:RegisterTickSpeed(53382, 2); -- set tick speed to 2 instead of 3	
			
		-- Holy Spells
		FW:RegisterSpell(31821, 0, 006, 0, FW.BUFF); -- Aura Mastery
		FW:RegisterSpell(53563, 1, 060, 0, FW.BUFF); -- Beacon of Light
			FW:RegisterSpellModGlph(53563, 63865, 1, 030); -- Glyph of Beacon of Light
		FW:RegisterSpell(48819, 0, 008, 0, FW.DEFAULT); -- Consecration
			FW:RegisterSpellModGlph(48819, 55114, 1, 002); -- Glyph of Consecration
		FW:RegisterSpell(31842, 0, 015, 0, FW.DEFAULT); -- Divine Illumination
		FW:RegisterSpell(48817, 0, 003, 0, FW.DEFAULT); -- Holy Wrath (stun)
		FW:RegisterSpell(20235, 1, 015, 0, FW.DEFAULT); -- Improved Lay on Hands
		FW:RegisterSpell(53601, 1, 030, 0, FW.BUFF); -- Sacred Shield
			FW:RegisterSpellModTlnt(53601, 53530, 1, 015); -- Divine Guardian (Rank 1)
			FW:RegisterSpellModTlnt(53601, 53530, 2, 030); -- Divine Guardian (Rank 2)
		FW:RegisterSpell(10326, 1, 020, 0, FW.DEFAULT); -- Turn Evil
		-- Protection Spells
		FW:RegisterSpell(48827, 1, 010, 0, FW.DEFAULT); -- Avenger's Shield (daze)
		FW:RegisterSpell(19752, 1, 180, 0, FW.DEFAULT); -- Divine Intervention	
		FW:RegisterSpell(498,   0, 012, 0, FW.DEFAULT); -- Divine Protection
		FW:RegisterSpell(64205, 0, 010, 0, FW.DEFAULT); -- Divine Sacrifice
		FW:RegisterSpell(10308, 1, 006, 0, FW.DEFAULT); -- Hammer of Justice (stun)
		FW:RegisterSpell(1044,  1, 006, 0, FW.BUFF); -- Hand of Freedom
			FW:RegisterSpellModTlnt(1044, 20174, 1, 2); -- Guardian's Favor (Rank 1)
			FW:RegisterSpellModTlnt(1044, 20175, 1, 4); -- Guardian's Favor (Rank 2)
		FW:RegisterSpell(10278, 1, 010, 0, FW.BUFF); -- Hand of Protection
		FW:RegisterSpell(62124, 1, 003, 0, FW.DEFAULT); -- Hand of Reckoning
		FW:RegisterSpell(6940,  1, 012, 0, FW.BUFF); -- Hand of Sacrifice
		FW:RegisterSpell(1038,  1, 010, 0, FW.BUFF); -- Hand of Salvation
		FW:RegisterSpell(48785, 1, 000, 0, FW.HEAL); -- Flash of Light
			FW:RegisterTickSpeed(48785, 1);
		
		-- Retribution Spells
		FW:RegisterSpell(31884, 0, 020, 0, FW.DEFAULT); -- Avenging Wrath
		FW:RegisterSpell(53407, 1, 020, 0, FW.DEFAULT); -- Judgement of Justice
		FW:RegisterSpell(20271, 1, 020, 0, FW.DEFAULT); -- Judgement of Light
		FW:RegisterSpell(53408, 1, 020, 0, FW.DEFAULT); -- Judgement of Wisdom
		FW:RegisterSpell(20066, 1, 060, 0, FW.DEFAULT); -- Repentance (stun)
		
		FW:RegisterSpell(31803, 1, 000, 1, FW.DEFAULT); -- Holy Vengeance
			FW:RegisterSpecialRefresh(31803);
		FW:RegisterSpell(53742, 1, 000, 1, FW.DEFAULT); -- Blood Corruption
			FW:RegisterSpecialRefresh(53742);

		-- Libram Buffs
		FW:RegisterBuff(71192); -- Blessed, 				     from Libram of Blinding Light [ilvl264]
		FW:RegisterBuff(71187); -- Formidable, 			     from Libram of Three Truths [ilvl264]
		FW:RegisterBuff(71197); -- Evasive, 				     from Libram of the Eternal Tower [ilvl264]

		FW:RegisterBuff(60553); -- Relentless Aggression, 		     from Relentless Gladiator's Libram of Fortitude [ilvl251]
		FW:RegisterBuff(67378); -- Evasion, 				     from Libram of Defiance [ilvl245]
		FW:RegisterBuff(67371); -- Holy Strength, 			     from Libram of Valiance [ilvl245]
		FW:RegisterBuff(60551); -- "Furious Gladiator's Libram of Fortitude",     from Furious Gladiator's Libram of Fortitude [ilvl232]
		FW:RegisterBuff(65182); -- Increased Block, 			     from Libram of the Sacred Shield [ilvl226]
		FW:RegisterBuff(60549); -- Deadly Aggression, 			     from Deadly Gladiator's Libram of Fortitude [ilvl213]
		FW:RegisterBuff(60547); -- Hateful Aggression, 			     from Hateful Gladiator's Libram of Fortitude [ilvl200]
		FW:RegisterBuff(60544); -- Savage Aggression, 			     from Savage Gladiator's Libram of Fortitude [ilvl200]
		
		FW:RegisterBuff(46089); -- Brutal Gladiator's Libram of Fortitude/Vengeance
		FW:RegisterBuff(46093); -- Brutal Gladiator's Libram of Justice
		FW:RegisterBuff(43839); -- Gladiator's Libram of Fortitude/Vengeance
		FW:RegisterBuff(34135); -- Gladiator's Libram of Justice
		FW:RegisterBuff(34260); -- Libram of Avengement
		FW:RegisterBuff(43747); -- Libram of Divine Judgement
		FW:RegisterBuff(48836); -- Libram of Furious Blows
		FW:RegisterBuff(43742); -- Libram of Mending
		FW:RegisterBuff(60795); -- Libram of Obstruction
		FW:RegisterBuff(60819); -- Libram of Reciprocation
		FW:RegisterBuff(43848); -- Merciless Gladiator's Libram of Fortitude/Vengeance
		FW:RegisterBuff(42369); -- Merciless Gladiator's Libram of Justice
		FW:RegisterBuff(41043); -- Tome of the Lightbringer
		FW:RegisterBuff(43849); -- Vengeful Gladiator's Libram of Fortitude/Vengeance
		FW:RegisterBuff(43727); -- Vengeful Gladiator's Libram of Justice
		
		FW:RegisterDebuff(25771); -- Forbearance
		
		FW:RegisterCasterBuffs();
		FW:RegisterMeleeBuffs();
	end
	if FW.Modules.Cooldown then
	
		-- Holy Buffs
		FW:RegisterCooldownBuff(48936); -- Blessing of Wisdom
		FW:RegisterCooldownBuff(48938); -- Greater Blessing of Wisdom
		FW:RegisterCooldownBuff(20165); -- Seal of Light
		FW:RegisterCooldownBuff(21084); -- Seal of Righteousness
		FW:RegisterCooldownBuff(20166); -- Seal of Wisdom

		-- Protection Buffs
		FW:RegisterCooldownBuff(20217); -- Blessing of Kings
		FW:RegisterCooldownBuff(20911); -- Blessing of Sanctuary
		FW:RegisterCooldownBuff(25898); -- Greater Blessing of Kings
		FW:RegisterCooldownBuff(25899); -- Greater Blessing of Sanctuary
		FW:RegisterCooldownBuff(25780); -- Righteous Fury
		FW:RegisterCooldownBuff(20164); -- Seal of Justice

		-- Retribution Buffs
		FW:RegisterCooldownBuff(27140); -- Blessing of Might
		FW:RegisterCooldownBuff(48934); -- Greater Blessing of Might
		FW:RegisterCooldownBuff(31892); -- Seal of Blood
		FW:RegisterCooldownBuff(20375); -- Seal of Command
		FW:RegisterCooldownBuff(53736); -- Seal of Corruption
		FW:RegisterCooldownBuff(53720); -- Seal of the Martyr
		FW:RegisterCooldownBuff(31801); -- Seal of Vengeance
        
		FW:RegisterCasterPowerupCooldowns();
		FW:RegisterMeleePowerupCooldowns();
		
		-- Divine Shield, Divine Protection and Avenging Wrath cannot be used within 30s of each other (3.0.8)
		local avenging_wrath = FW:SpellName(31884);
		local divine_protection = FW:SpellName(498);
		local divine_shield = FW:SpellName(642);
		local hand_of_protection = FW:SpellName(10278);
		
		FW:RegisterOnCooldownUsed(function(s,d)
			if d~=30 then -- don't trigger any of the other hidden cooldowns if it's already a hidden cooldown
				if s == avenging_wrath then
					FW:HiddenCooldown(divine_shield, 030, "Interface\\Icons\\Spell_Holy_DivineIntervention");
					FW:HiddenCooldown(divine_protection, 030, "Interface\\Icons\\Spell_Holy_Restoration");
					FW:HiddenCooldown(hand_of_protection, 030, "Interface\\Icons\\Spell_Holy_SealofProtection");
				
				elseif s == divine_shield or s == divine_protection or s == hand_of_protection then
					FW:HiddenCooldown(avenging_wrath, 030, "Interface\\Icons\\Spell_Holy_AvengineWrath");
				
				end
			end
		end);
	end
end

